- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.UsableSubnetworksAggregatedList.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.UsableSubnetworksAggregatedList.SCHEMA_REPRESENTATION.item.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.UsableSubnetworksAggregatedList.SCHEMA_REPRESENTATION.warning.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.UsableSubnetworksAggregatedList.SCHEMA_REPRESENTATION.scoped_warnings.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#body.aspect)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/subnetworks/listUsable#try-it)

Retrieves an aggregated list of all usable subnetworks in the project.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/beta/projects/{project}/aggregated/subnetworks/listUsable`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |

### Query parameters

| Parameters ||
|---|---|
| `maxResults` | `integer (https://developers.google.com/discovery/v1/type-format format)` The maximum number of results per page that should be returned. If the number of available results is larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`) |
| `pageToken` | `string` Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list request to get the next page of results. |
| `filter` | `string` A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal [AIP-160](https://google.aip.dev/160). These two types of filter expressions cannot be mixed in one request. If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either `=`, `!=`, `>`, `<`, `<=`, `>=` or `:`. For example, if you are filtering Compute Engine instances, you can exclude instances named `example-instance` by specifying `name != example-instance`. The `:*` comparison can be used to test whether a key has been defined. For example, to find all objects with `owner` label use: labels.owner:* You can also filter nested fields. For example, you could specify `scheduling.automaticRestart = false` to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on [resource labels](https://docs.cloud.google.com/compute/docs/labeling-resources). To filter on multiple expressions, provide each separate expression within parentheses. For example: (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") By default, each expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For example: (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND (scheduling.automaticRestart = true) If you want to use a regular expression, use the `eq` (equal) or `ne` (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples: `fieldname eq unquoted literal` `fieldname eq 'single quoted literal'` `fieldname eq "double quoted literal"` `(fieldname1 eq literal) (fieldname2 ne "literal")` The literal value is interpreted as a regular expression using Google [RE2](https://github.com/google/re2/wiki/Syntax) library syntax. The literal value must match the entire field. For example, to filter for instances that do not end with name "instance", you would use `name ne .*instance`. You cannot combine constraints on multiple fields using regular expressions. |
| `orderBy` | `string` Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name. You can also sort results in descending order based on the creation timestamp using `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first. Currently, only sorting by `name` or `creationTimestamp desc` is supported. |
| `returnPartialSuccess` | `boolean` Opt-in for partial success behavior which provides partial results in case of failure. The default value is false. For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code. |
| `serviceProject` | `string` The project id or project number in which the subnetwork is intended to be used. Only applied for Shared VPC. See [Shared VPC documentation](https://cloud.google.com/vpc/docs/shared-vpc/) |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "items": [ { "subnetwork": string, "network": string, "ipCidrRange": string, "secondaryIpRanges": [ { "rangeName": string, "ipCidrRange": string } ], "stackType": enum, "ipv6AccessType": enum, "purpose": enum, "role": enum, "externalIpv6Prefix": string, "internalIpv6Prefix": string } ], "nextPageToken": string, "selfLink": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] }, "unreachables": [ string ], "scopedWarnings": [ { "scopeName": string, "warning": { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } } ] } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of resource. Always `compute#usableSubnetworksAggregatedList` for aggregated lists of usable subnetworks. |
| `id` | `string` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `items[]` | `object` \[Output\] A list of usable subnetwork URLs. |
| `items[].subnetwork` | `string` Subnetwork URL. |
| `items[].network` | `string` Network URL. |
| `items[].ipCidrRange` | `string` The range of internal addresses that are owned by this subnetwork. |
| `items[].secondaryIpRanges[]` | `object` Secondary IP ranges. |
| `items[].secondaryIpRanges[].rangeName` | `string` The name associated with this subnetwork secondary range, used when adding an alias IP range to a VM instance. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). The name must be unique within the subnetwork. |
| `items[].secondaryIpRanges[].ipCidrRange` | `string` The range of IP addresses belonging to this subnetwork secondary range. Can be Ipv4 or Ipv6 range. |
| `items[].stackType` | `enum` The stack type for the subnet. If set to `IPV4_ONLY`, new VMs in the subnet are assigned IPv4 addresses only. If set to `IPV4_IPV6`, new VMs in the subnet can be assigned both IPv4 and IPv6 addresses. If not specified, `IPV4_ONLY` is used. This field can be both set at resource creation time and updated using `patch`. |
| `items[].ipv6AccessType` | `enum` The access type of IPv6 address this subnet holds. It's immutable and can only be specified during creation or the first time the subnet is updated into IPV4_IPV6 dual stack. |
| `items[].purpose` | `enum` |
| `items[].role` | `enum` The role of subnetwork. Currently, this field is only used when purpose is set to `GLOBAL_MANAGED_PROXY` or `REGIONAL_MANAGED_PROXY`. The value can be set to `ACTIVE` or `BACKUP`. An `ACTIVE` subnetwork is one that is currently being used for Envoy-based load balancers in a region. A `BACKUP` subnetwork is one that is ready to be promoted to `ACTIVE` or is currently draining. This field can be updated with a `patch` request. |
| `items[].externalIpv6Prefix` | `string` Output only. The external IPv6 address range that is assigned to this subnetwork. |
| `items[].internalIpv6Prefix` | `string` Output only. The internal IPv6 address range that is assigned to this subnetwork. |
| `nextPageToken` | `string` Output only. This token allows you to get the next page of results for list requests. If the number of results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken` in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging through the results. In special cases `listUsable` may return 0 subnetworks and `nextPageToken` which still should be used to get the next page of results. |
| `selfLink` | `string` Output only. Server-defined URL for this resource. |
| `warning` | `object` Output only. Informational warning message. |
| `warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `warning.message` | `string` Output only. A human-readable description of the warning code. |
| `warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |
| `unreachables[]` | `string` Output only. Unreachable resources. |
| `scopedWarnings[]` | `object` Output only. Informational warning messages for failures encountered from scopes. |
| `scopedWarnings[].scopeName` | `string` Name of the scope containing this set of Subnetworks. |
| `scopedWarnings[].warning` | `object` An informational warning about unreachable scope |
| `scopedWarnings[].warning.code` | `enum` Output only. A warning code, if applicable. For example, Compute Engine returns `NO_RESULTS_ON_PAGE` if there are no results in the response. |
| `scopedWarnings[].warning.message` | `string` Output only. A human-readable description of the warning code. |
| `scopedWarnings[].warning.data[]` | `object` Output only. Metadata about this warning in `key: value` format. For example: ```html "data": [  {  "key": "scope",  "value": "zones/us-east1-d"  }] ``` <br /> |
| `scopedWarnings[].warning.data[].key` | `string` Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be `scope` and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding). |
| `scopedWarnings[].warning.data[].value` | `string` Output only. A warning data value corresponding to the key. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).